// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	m_pDevice = NULL;
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_RUN, OnBtnRun)
	ON_BN_CLICKED(IDC_BTN_STOP, OnBtnStop)
	ON_BN_CLICKED(IDC_RADIO_SEND, OnRadioSend)
	ON_BN_CLICKED(IDC_RADIO_RECV, OnRadioRecv)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	EnumDevice();
	
	InitBaud();

	CreateView();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlg::OnBtnRun() 
{
	// TODO: Add your control notification handler code here
	int nPort = ((CComboBox*)GetDlgItem(IDC_COMBO_DEVICE))->GetItemData(((CComboBox*)GetDlgItem(IDC_COMBO_DEVICE))->GetCurSel());
	int nBaud = ((CComboBox*)GetDlgItem(IDC_COMBO_BAUD))->GetItemData(((CComboBox*)GetDlgItem(IDC_COMBO_BAUD))->GetCurSel());
	m_pDevice = OpenDevice(nPort,nBaud);
	if(m_pDevice)
	{
		GetDlgItem(IDC_BTN_RUN)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_STOP)->EnableWindow(TRUE);
	}
}

void CDemoDlg::EnumDevice()
{
	HDEVINFO hDevInfo;
	SP_DEVINFO_DATA DeviceInfoData;
	DWORD i;
	
	// Create a HDEVINFO with all present devices.
	hDevInfo = SetupDiGetClassDevs(NULL,
		0, // Enumerator
		0,
		DIGCF_PRESENT | DIGCF_ALLCLASSES );
	
	if (hDevInfo == INVALID_HANDLE_VALUE)
	{
		// Insert error handling here.
		return ;
	}
	
	// Enumerate through all devices in Set.
	DeviceInfoData.cbSize = sizeof(SP_DEVINFO_DATA);
	for (i=0;SetupDiEnumDeviceInfo(hDevInfo,i,&DeviceInfoData);i++)
	{
		DWORD DataT;
		LPTSTR buffer = NULL;
		DWORD buffersize = 0;
		
		// 
		// Call function with null to begin with, 
		// then use the returned buffer size 
		// to Alloc the buffer. Keep calling until
		// success or an unknown failure.
		// 
		while (!SetupDiGetDeviceRegistryProperty(
			hDevInfo,
			&DeviceInfoData,
			SPDRP_FRIENDLYNAME,
			&DataT,
			(PBYTE)buffer,
			buffersize,
			&buffersize))
		{
			if (GetLastError() == ERROR_INSUFFICIENT_BUFFER)
			{
				// Change the buffer size.
				if (buffer)
				{
					delete [] buffer;
					buffer = 0;
				}
				buffer = new char[buffersize];
			}
			else
			{
				// Insert error handling here.
				break;
			}
		}
		if (DeviceInfoData.ClassGuid == GUID_DEVCLASS_PORTS)
		{
			if (strstr(buffer,"COM"))
			{
				char port[6] = {0};
				int len = strlen(buffer);
				for (int i = 0; i<8;i++)
				{
					if (buffer[len-i] == 'M' )
					{
						strcpy(port,(buffer+(len-i+1)));
						port[strlen(port)-1] = 0;
						int nPort = atoi(port);
						CString strPort;
						strPort.Format("COM%d",nPort);
						int nIndex = ((CComboBox*)GetDlgItem(IDC_COMBO_DEVICE))->AddString(strPort);
						((CComboBox*)GetDlgItem(IDC_COMBO_DEVICE))->SetItemData(nIndex,nPort);
						break;
					}
				}
			}
		}
		if (buffer)
		{
			delete [] buffer;
			buffer = 0;
		}
	}
}

void CDemoDlg::InitBaud()
{
	int nIndex = ((CComboBox*)GetDlgItem(IDC_COMBO_BAUD))->AddString("115200");
	((CComboBox*)GetDlgItem(IDC_COMBO_BAUD))->SetItemData(nIndex,115200);
	nIndex = ((CComboBox*)GetDlgItem(IDC_COMBO_BAUD))->AddString("9600");
	((CComboBox*)GetDlgItem(IDC_COMBO_BAUD))->SetItemData(nIndex,9600);
}

void CDemoDlg::OnBtnStop() 
{
	// TODO: Add your control notification handler code here
	if(m_pDevice)
	{
		CloseDevice(m_pDevice);
		GetDlgItem(IDC_BTN_STOP)->EnableWindow(FALSE);
		GetDlgItem(IDC_BTN_RUN)->EnableWindow(TRUE);
		m_pDevice = NULL;
	}
}

void CDemoDlg::CreateView()
{
	CRect rect;
	GetDlgItem(IDC_FRAME_VIEW)->GetWindowRect(&rect);

	ScreenToClient(&rect);

	m_viewSend.Create(IDD_DLG_SEND,this);
	m_viewRecv.Create(IDD_DLG_RECV,this);

	rect.left += 1;
	rect.top += 1;
	rect.right -= 1;
	rect.bottom -= 1;

	m_viewSend.MoveWindow(&rect);
	m_viewRecv.MoveWindow(&rect);

	m_viewSend.ShowWindow(SW_SHOW);
}

void CDemoDlg::OnRadioSend()
{
	// TODO: Add your control notification handler code here
	m_viewSend.ShowWindow(SW_SHOW);
	m_viewRecv.ShowWindow(SW_HIDE);
}

void CDemoDlg::OnRadioRecv()
{
	// TODO: Add your control notification handler code here
	m_viewSend.ShowWindow(SW_HIDE);
	m_viewRecv.ShowWindow(SW_SHOW);	
}
